/*
****************************************************************************
****************************************************************************
**                                                                        **
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIAYSTOK 2014                               **
**                                                                        **
**                         Home Control System                            **
**                                                                        **
**                              HC_CTRL1                                  **
**                      Wersja z dnia : 2018.07.29                        **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/


#ifndef _CTRL1EEPROM_
#define _CTRL1EEPROM_

#include <inttypes.h>

#define _KeyExtend_

#define StandardSygnature              0xA55A
#define EEBlockAddressOffset           4

#define NoActive                       0xFF

#define DeviceIDSize                   8
typedef uint8_t DeviceIDType [ DeviceIDSize + 1 ] ;

#define CommandBufferSize              16
typedef uint8_t CommandBufferType [ CommandBufferSize + 1 ] ;

#define ParamNameSize                  8
typedef uint8_t ParamNameType [ ParamNameSize + 1 ] ;

typedef struct {
                 DeviceIDType      DestDevice ;
                 ParamNameType     ParamName ;
                 uint8_t           KeyCode ;
               } KeyCommDescrRecT ;
typedef KeyCommDescrRecT * PtrKeyCommDescrRecT ;

typedef struct {
                 KeyCommDescrRecT CommDescr ;
                 uint8_t          CommKey ;
               } KeyCommParamRecT ;

#define PasswordSize                   6
typedef uint8_t PasswordType [ PasswordSize + 1 ] ;

#define ChannelsArraySize              8
#define DisplParamArraySize            8
#define KeyCommTableSize               24

typedef enum {
               FunctionDispMode ,
               StatusDispMode ,
             } LEDModeSwitchT ;

typedef struct {
                 uint16_t             EEBlockMetric ;
                 DeviceIDType         MyDeviceID ;
                 DeviceIDType         SubDeviceID [ ChannelsArraySize ] ;                       //4
                 PasswordType         Password ;
                 ParamNameType        DisplParamDescr [ DisplParamArraySize ] ;                 //8
                 KeyCommDescrRecT     KeyCommTable [ KeyCommTableSize ] ;
                 LEDModeSwitchT       DisplayMode ;
                 uint8_t              StartKeyCode ;
                 uint16_t             CRCValue ;
               } EEPROMBlockDataRecT ;

extern EEPROMBlockDataRecT EEBlock ;

void SetDefaultEEBlock ( void ) ;

#endif
